天天看點

POJ 3126 Prime Path(經典廣搜BFS)

題目連結:http://poj.org/problem?id=3126

Prime Path

Time Limit: 1000MS Memory Limit: 65536K

Total Submissions: 20231 Accepted: 11278

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3

1033 8179

1373 8017

1033 1033

Sample Output

6

7

【中文題意】給你兩個素數,問你第一個素數至少要經過多少次變換能變成第二個素數,如果不可能的話輸出“Impossible”每一次變換應滿足一下兩個條件:

1.隻能改變個十百千4個位數中的一個。

2.變成的新的數必須也得是素數

【思路分析】我們可以直接用篩法篩出1W以内的素數,然後用搜尋的辦法求出最小變換次數,具體看一下代碼的注釋。

【AC代碼】

#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<queue>
using namespace std;

bool isprime[],book[];
void doprime()
{
    memset(isprime,,sizeof(isprime));
    isprime[]=;
    for(int i=;i<=;i++)
    {
        if(isprime[i])
        for(int j=*i;j<=;j+=i)
        {
            isprime[j]=;
        }
    }
}

struct node
{
    int x,step;
};

int bfs(int s,int t)
{
    memset(book,,sizeof(book));
    book[s]=;
    node fr,ne;
    fr.x=s;
    fr.step=;
    queue<node>q;
    q.push(fr);
    while(!q.empty())
    {
        fr=q.front();
        q.pop();
        if(fr.x==t)
        {
            return fr.step;
        }
        int n4=fr.x%10,n3=(fr.x/)%10,n2=(fr.x/)%10,n1=(fr.x/)%10;
        for(int i=;i<=;i++)//千位
        {
            int y=i*1000+n2*100+n3*10+n4;
            if(book[y]==&&isprime[y])
            {
                book[y]=;
                ne.x=y;
                ne.step=fr.step+;
                q.push(ne);
            }
        }
        for(int i=;i<=;i++)//百位
        {
            int y=n1*1000+i*100+n3*10+n4;
            if(book[y]==&&isprime[y])
            {
                book[y]=;
                ne.x=y;
                ne.step=fr.step+;
                q.push(ne);
            }
        }
        for(int i=;i<=;i++)//十位
        {
            int y=n1*1000+n2*100+i*10+n4;
            if(book[y]==&&isprime[y])
            {
                book[y]=;
                ne.x=y;
                ne.step=fr.step+;
                q.push(ne);
            }
        }
        for(int i=;i<=;i++)//個位
        {
            int y=n1*1000+n2*100+n3*10+i;
            if(book[y]==&&isprime[y])
            {
                book[y]=;
                ne.x=y;
                ne.step=fr.step+;
                q.push(ne);
            }
        }
    }
    return -;
}

int main()
{
    doprime();
    int t,m,n;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        int re=bfs(n,m);
        int x=m;
        if(re==-)
        {
            printf("Impossible\n");
        }
        else
        printf("%d\n",re);
    }
    return ;
}